'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var reactRouterDom = require('react-router-dom');
var PropTypes = _interopDefault(require('prop-types'));
var reactRouter = require('react-router');

var preHistory = Symbol('rs__unique__pre_History_____');
var curHistory = Symbol('rs__unique__cur_History_____');
var __win_AllRoutes = Symbol('rs__unique__AllRoutes___');
var __init = Symbol('rs__unique__initFlag___');

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var log = function log() {
    // if (process.env.NODE_ENV === 'production') return;
    // console.log(...arguments)
};
var wrapParent = function wrapParent(r) {
    var comp = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var props = arguments[2];

    var target = r.component ? React.createElement(
        r.component,
        props,
        ' ',
        r.children ? comp : null
    ) : null;
    if (r.__parent && r.__parent.component) {
        return wrapParent(r.__parent, target, props);
    }
    return target;
};
var locationEqual = function locationEqual(a, b) {
    if ((typeof a === 'undefined' ? 'undefined' : _typeof(a)) !== 'object' || (typeof b === 'undefined' ? 'undefined' : _typeof(b)) !== 'object') {
        return false;
    }
    if (!a.pathname || !b.pathname) {
        return false;
    }
    return a.pathname === b.pathname && a.search === b.search && a.hash === b.hash;
};
var inorderRoutes = function inorderRoutes(r, route) {
    var res = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

    if (r.path && (r.component || r.redirect)) {
        res.push(route(r));
    }
    if (Array.isArray(r.children) && r.children.length) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
            for (var _iterator = r.children[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                var x = _step.value;

                x['__parent'] = r;
                inorderRoutes(x, route, res);
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion && _iterator.return) {
                    _iterator.return();
                }
            } finally {
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    if (Array.isArray(r.aliasPath) && r.aliasPath.length) {
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
            for (var _iterator2 = r.aliasPath[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                var path = _step2.value;

                if (!/^\//.test(path)) {
                    path = '/' + path;
                }
                res.push(route(Object.assign({}, r, { path: path, aliasPath: null })));
            }
        } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
        } finally {
            try {
                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                    _iterator2.return();
                }
            } finally {
                if (_didIteratorError2) {
                    throw _iteratorError2;
                }
            }
        }
    }
    return res;
};
var completeAllRoutes = function completeAllRoutes(routesArr, indexPath, noFoundPath) {
    routesArr = routesArr.concat([indexPath ? React.createElement(reactRouterDom.Route, { key: '/', exact: true, path: '/', render: function render() {
            return React.createElement(reactRouterDom.Redirect, { to: indexPath });
        } }) : null, noFoundPath ? React.createElement(reactRouterDom.Route, { key: noFoundPath, render: function render() {
            return React.createElement(reactRouterDom.Redirect, { to: noFoundPath });
        } }) : null]).filter(Boolean);
    window[__win_AllRoutes] = routesArr;
    return routesArr;
};
function push(url) {
    if (window[curHistory]) {
        window[curHistory].push(url);
    } else {
        // createHistory().push(url)
        window.location.href = url;
    }
}
function __beforeEach(params) {
    var _this = this;

    var beforeEach = this.props.beforeEach;
    var state = params.state,
        afterEach = params.afterEach,
        action = params.action;
    var pre = window[preHistory] || {},
        cur = window[curHistory] || {};

    var location = params.location || cur.location;
    if (state === 'mount') {
        var _ref = [cur.location, null],
            to = _ref[0],
            from = _ref[1];

        beforeEach(to, from, function () {
            var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

            if (params && (typeof params === 'undefined' ? 'undefined' : _typeof(params)) !== 'object') {
                throw TypeError('params type must be object');
            }
            if (params && params.path) {
                push(params.path);
                return;
            }
            _this.setState({
                finished: true
            }, function () {
                afterEach();
            });
        });
    } else if (state === 'prompt') {

        if (locationEqual(cur.location, location)) {
            return false;
        }
        var pathname = location.pathname,
            search = location.search;
        var _ref2 = [location, cur.location],
            _to = _ref2[0],
            _from = _ref2[1];

        var next = function next(params) {
            if (params && (typeof params === 'undefined' ? 'undefined' : _typeof(params)) !== 'object') {
                throw TypeError('params type must be object');
            }
            //此处置为false为了next跳转时prompt能顺利跳转
            _this.promptPendding = false;

            if (params && params.path) {
                push(params.path);
                return;
            }
            if (action === 'POP') {
                cur.goBack();
            } else {
                //跳转,补全search
                push(pathname + search);
            }
        };
        beforeEach && beforeEach(_to, _from, next);
        return !beforeEach;
    }
}
var utils = {};
Object.defineProperty(utils, 'history', {
    get: function get$$1() {
        return window[curHistory];
    }
});
Object.defineProperty(utils, 'route', {
    get: function get$$1() {
        return window[curHistory] ? window[curHistory].route : null;
    }
});
Object.defineProperty(utils, 'push', {
    get: function get$$1() {
        return function (path) {
            window[curHistory] ? window[curHistory].push(path) : window.location.push(path);
        };
    }
});
var rsUtils = utils;

var AsyncRoute = function (_React$Component) {
    inherits(AsyncRoute, _React$Component);

    function AsyncRoute(props) {
        classCallCheck(this, AsyncRoute);

        var _this = possibleConstructorReturn(this, (AsyncRoute.__proto__ || Object.getPrototypeOf(AsyncRoute)).call(this));

        _this.state = {
            finished: false
        };
        return _this;
    }

    createClass(AsyncRoute, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            //log('AsyncRoute:componentDidMount')
            var _props = this.props,
                beforeEach = _props.beforeEach,
                afterEach = _props.afterEach,
                isPrompt = _props.isPrompt,
                setPromptPendding = _props.setPromptPendding;

            log('window[__init]', window[__init]);
            if (!isPrompt || !window[__init]) {
                //首次加载不走prompt
                window[__init] = true;

                //首次加载的时候在mouted里做异步
                if (beforeEach) {

                    __beforeEach.call(this, {
                        state: 'mount',
                        afterEach: afterEach // 首次加载的afterEach
                    });
                } else {
                    afterEach && afterEach();
                }
            } else {
                //切换的时候在prompt组件中做异步
                if (beforeEach) {
                    //切换完毕后
                    //重置 prompt 的 pedding状态
                    setPromptPendding(true);
                }
                if (afterEach) {
                    afterEach();
                }
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var finished = this.state.finished;
            var _props2 = this.props,
                wp = _props2.wp,
                beforeEach = _props2.beforeEach,
                isPrompt = _props2.isPrompt;

            if (isPrompt && window[__init]) {
                //且首次加载的情况下
                //切换的时候在prompt里做异步，此组件（AsyncRoute）变为同步组件
                return wp;
            }            return !beforeEach || finished ? wp : null;
        }
    }]);
    return AsyncRoute;
}(React.Component);

AsyncRoute.propsTypes = {
    beforeEach: PropTypes.func
};

/**
 * 1 重复路由跳转问题；包括重定向前后一样的路由
 * 2 所有：路由参数 的考虑(无需考虑锚点)
 * 3 跳转不存在路由去跳转404 ；包括find方法中容错处理
 */

/**
 * promp(ifEqual) --> beforeEach --> next() --> push( to/redirect )
 *         |               |  
 *       return            |  -->  next({path}) --> push( path/redirect )
 *                     
 * */

var RouterStrong = function (_React$Component) {
    inherits(RouterStrong, _React$Component);

    function RouterStrong(props) {
        classCallCheck(this, RouterStrong);

        var _this = possibleConstructorReturn(this, (RouterStrong.__proto__ || Object.getPrototypeOf(RouterStrong)).call(this));

        _this.promptPendding = !!props.beforeEach;
        /**
         *  Promp (true) --> Route( render)
         */
        return _this;
    }

    createClass(RouterStrong, [{
        key: 'message',
        value: function message(location, action) {
            this.isPrompt = true;
            /**
             * 返回值为
             * true直接跳转路由
             * false阻断路由跳转
             */
            //特例：首次加载'/'因为redirect而走的prompt直接通过
            if (!window[__init]) {
                return true;
            }
            // 思路：
            // 有beforeEach 则跳转前把promptPendding=true
            // 直到next执行后 promptPendding=false
            log('promptPendding', this.promptPendding);
            if (!this.promptPendding) {
                //★★★重点★★★
                //跳转相同的pathname的时候
                //因为不会重新render组件，故不能在组件里重置promptPendding
                //只能在这里重置
                if (location.pathname === window[curHistory].location.pathname) {
                    this.promptPendding = true;
                }
                return true;
            }
            //切换的时候，有beforeEach为false阻止跳转
            return __beforeEach.call(this, {
                state: 'prompt',
                location: location,
                action: action
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                config = _props.config,
                mode = _props.mode,
                _props$isSwitch = _props.isSwitch,
                isSwitch = _props$isSwitch === undefined ? true : _props$isSwitch,
                indexPath = _props.indexPath,
                noMatch = _props.noMatch,
                beforeEach = _props.beforeEach,
                afterEach = _props.afterEach;


            var Router = mode === 'history' ? reactRouterDom.BrowserRouter : reactRouterDom.HashRouter;

            var routesArr = config.map(function (r) {
                var route = function route(r) {
                    var routeParams = function routeParams(r) {
                        return {
                            key: r.path,
                            exact: true,
                            path: r.path,
                            __r: r,
                            __parent: r.__parent,
                            render: function render(props) {
                                props.history = _extends({}, props.history, { route: r });
                                window[preHistory] = window[curHistory] || {};
                                window[curHistory] = props.history;
                                //log('render-props', props);
                                var merge = _extends({}, props, {
                                    route: r
                                });
                                if (r.redirect) {
                                    return React.createElement(reactRouterDom.Redirect, _extends({}, merge, { to: r.redirect }));
                                }
                                var wp = wrapParent(r, null, merge);
                                return React.createElement(AsyncRoute, {
                                    wp: wp,
                                    setPromptPendding: function setPromptPendding(bool) {
                                        return _this2.promptPendding = bool;
                                    },
                                    isPrompt: _this2.isPrompt,
                                    beforeEach: beforeEach,
                                    afterEach: afterEach
                                });
                            }
                        };
                    };

                    return React.createElement(reactRouterDom.Route, routeParams(r));
                };
                return inorderRoutes(r, route, []);
            }).flat();
            var AllRoutes = completeAllRoutes(routesArr, indexPath, noMatch);
            return React.createElement(
                Router,
                null,
                React.createElement(reactRouter.Prompt, { message: this.message.bind(this) }),
                this.props.children,
                isSwitch ? React.createElement(
                    reactRouterDom.Switch,
                    null,
                    '  ',
                    AllRoutes,
                    '  '
                ) : AllRoutes
            );
        }
    }]);
    return RouterStrong;
}(React.Component);

RouterStrong.propsTypes = {
    routes: PropTypes.array.isRequired,
    mode: PropTypes.string,
    beforeEach: PropTypes.func,
    afterEach: PropTypes.func,
    isSwitch: PropTypes.bool
};

exports.default = RouterStrong;
exports.rsUtils = rsUtils;
//# sourceMappingURL=index.js.map
